(defun 2d3d (P1 Z)
   (list
      (car P1)   ; X value.
      (cadr P1)  ; Y value.
      Z))
;
(defun 3d2d (P1)
   (list
      (car P1)    ; X value.
      (cadr P1))) ; Y value.
;
(defun 3dmid (P1 P2)
   (list

     (/             ; X value calculation,
       (+           ; add X values of points
          (car P1)
          (car P2))
       2.0)         ; then divide by 2.

     (/             ; Y value calculations
       (+
          (cadr P1)
          (cadr P2))
       2.0)

     (/             ; Z value calculations
       (+
          (caddr P1)
          (caddr P2))
       2.0)))
;
(defun delta_xy (P1 P2)
   (distance
      (3d2d P1)
      (3d2d P2)))
(defun 3dangle (P1 P2)  ; returns (THETA PHI)
   (list
     (atan
       (-
          (cadr P2)
          (cadr P1))
       (-
          (car P2)
          (car P1)))
      (atan
       (-
           (caddr P2)
           (caddr P1))
       (delta_XY P1 P2))))
;
(defun 3dpolar (P1 Theta Phi Dist)
   (if (> PHI (* 2 PI))
       (setq PHI (rem PHI (* 2 PI))))
   (if (> THETA (* 2 PI))
       (setq THETA (rem THETA (* 2 PI))))
   (if (> (abs PHI) PI)
       (setq PHI
          (if (minusp PHI)
              (+
                  (* 2 PI)
                  PHI)
              (-
                  PHI
                  (* 2 PI)))))
   (if (> (abs PHI) (/ PI 2))
       (setq THETA (rem (+ PI THETA) (* 2 PI))
             PHI (rem PHI (/ PI 2))))
   (list
      (+
         (car P1)
         (*
            (cos THETA)
            (cos PHI)
            DIST))
      (+
         (cadr P1)
         (*
            (cos PHI)
            (sin THETA)
            DIST))
      (+
         (caddr P1)
         (*
            (sin Phi)
            DIST))))