#: 4178 S1/AutoCAD
    16-Sep-86  00:31:41
Sb: #4162-LISP
Fm: Duff Kurland [ADESK] 72407,2764
To: MIKE HERBOLD 72327,2155

Mike - Here's a suggested replacement for your C:BAL function. It simply uses
the LINE command to draw the multi-segment line with rubber band (although you
might note that V2.5's GETPOINT function now supports a "base" point for this
purpose).

(defun C:BAL ( / pt1 pt2 a p)
  (command "line")                     ; begin LINE command
  (command (setq pt1 (getpoint)))      ; get start point
  (while (setq pt2 (getpoint))         ; loop until null reply
     (command pt2)                     ; submit "to" point
     (setq a (angle pt1 pt2))          ; angle from pt1 to pt2
     (setq p (polar pt2 a 0.1875))     ; possible block insert pt
     (setq pt1 pt2)                    ; ready for next "to" point
  )
  (command "")                         ; end LINE command
  (command "insert" "balloon" p 1 1 0) ; insert balloon block
)

I think that'll do everything you want.
