(vmon)
;GET INFORMATION FOR BOX
(defun inbox ()
     (setq l (getdist "\nENTER LENGTH OF BOX "))
     (setq w (getdist "\nENTER WIDTH OF BOX "))
     (setq wt (getdist "\nENTER WALL THICKNESS "))
     (setq fe (getdist "\nENTER FOOTING EXTENSION")) 
     (setq ol (+ l (* 2 wt)))
     (setq ow (+ w (* 2 wt)))
)

;DRAW PLANS
(defun bsp ()
     (setq spoy 0)
     ;SETUP COORDINATES OF OUTSIDE OF BOX
     (setq s 10)
     (setq spx1 (+ s ol))
     (setq spy1 (+ spoy 10))
     (setq spy2 (+ spy1 ow))
     (setq sp1 (list s spy1))
     (setq sp2 (list spx1 spy1))
     (setq sp3 (list spx1 spy2))
     (setq sp4 (list s spy2))
     ;DRAW OUTSIDE OF BOX
     (command "layer" "s" "g3" \r)
     (command "line" sp1 sp2 sp3 sp4 sp1 "")
     ;SET UP COORDONATES FOR DIMENSIONING
     (setq odvloc (list (- s 9) spy1))
     (setq odhloc (list spx1 (+ spy2 9)))
     (setq odw (rtos (* 12 ow) 4 1))
     (setq odl (rtos (* 12 ol) 4 1))
     ;DRAW OUTSIDE DIMENSIONS
     (command "layer" "s" "sooo" \r
              "dim" "vert" sp1 sp4 odvloc odw "exit" 
              "dim" "horiz" sp4 sp3 odhloc odl "exit")
     ;SETUP COORDINATESOF INSIDE WALL FOR SECTIONAL PLAN
     (setq spx2 (+ s wt))
     (setq spx3 (+ spx2 l))
     (setq spy3 (+ spy1 wt))
     (setq spy4 (+ spy3 w))
     (setq sp5 (list spx2 spy3))
     (setq sp6 (list spx3 spy3))
     (setq sp7 (list spx3 spy4))
     (setq sp8 (list spx2 spy4))
     ;DRAW INSIDE OF WALL
     (command "layer" "s" "g3" \r
              "line" sp5 sp6 sp7 sp8 sp5 "")
     ;SETUP COORDINATES FOR FOOTING EXTENSION
     (setq spx4 (- s fe))
     (setq spx5 (+ spx1 fe))
     (setq spy5 (- spy1 fe))
     (setq spy6 (+ spy2 fe))
     (setq sp9 (list spx4 spy5))
     (setq sp10 (list spx5 spy5))
     (setq sp11 (list spx5 spy6))
     (setq sp12 (list spx4 spy6))
     ;DRAW FOOTING EXTENSION
     (command "layer" "s" "soo" \r
              "line" sp9 sp10 sp11 sp12 sp9 "")
     ;SETUP COORDINATES FOR WALL DIMMENSIONING
     (setq idvloc (list (- s 8) spy1))
     (setq idhloc (list s (+ spy2 8)))
     (setq idwt (rtos (* 12.0 wt) 4 1))
     (setq idw (rtos (* 12.0 w) 4 1))
     (setq idfe (rtos (* 12.0 fe) 4 1))
     (setq idl (rtos (* 12.0 l) 4 1))
     ;DRAW INSIDE DIMENSIONS
     (command "layer" "s" "sooo" \r
              "dim" "vert" sp1 sp5 idvloc idwt "cont" sp8 idw "cont"  sp4 idwt "cont" sp12 idfe "exit"
              "dim" "horiz" sp4 sp8 idhloc idwt "cont"  sp7 idl "cont" sp3 idwt "cont" sp11 idfe "exit")
     ;FIND OUT IF THERE IS A LEFT PIPE
     (setq pleft (getstring "\nIS THERE A PIPE ON THE LEFT SIDE? (Y or N)"))
     (if (= pleft "Y") (progn
     ;GET INFO ON PIPE
     (setq pldiam (getdist "\nWHAT IS THE DIAMETER OF THE LEFT PIPE?"))
     (setq plloc (getdist "\nDISTANCE FROM THE LOWER LEFT CORNER OF BOX TO THE CL OF PIPE?"))
     ;SET UP COORDINATES OF PIPE
     (setq yplpcl (+ plloc spy3))
     (setq plpcl (list spx2 yplpcl))
     ;INSERT PIPES
     (command "layer" "s" "g3" \r
              "insert" "/acad/strblk/rcp" plpcl 4 pldiam 180)
     ;DRAW LOCATIONS OF PIPES
     (setq xpldloc (- s 7))
     (setq pldloc (list xpldloc spy3))
     (setq pld (rtos (* 12 plloc) 4 1))
     (command "layer" "s" "sooo" \r
              "dim" "vert" pldloc plpcl pldloc pld "exit"))
)
    ;FIND OUT IF THERE IS A RIGHT PIPE
     (setq pright (getstring "\nIS THERE A PIPE ON THE RIGHT SIDE? (Y or N)"))
     (if (= pright "Y") (progn
     ;GET INFO ON PIPE
     (setq prdiam (getdist "\nWHAT IS THE DIAMETER OF THE RIGHT PIPE?"))
     (setq prloc (getdist "\nDISTANCE FROM THE LOWER RIGHT CORNER OF BOX TO THE CL OF PIPE?"))
     ;SET UP COORDINATES OF PIPE
     (setq yprpcl (+ prloc spy3))
     (setq prpcl (list spx3 yprpcl))
     ;INSERT PIPES
     (command "layer" "s" "g3" \r
              "insert" "/acad/strblk/rcp" prpcl 4 prdiam 0)
     ;DRAW LOCATIONS OF PIPES
     (setq xprdloc (+ spx1 7))
     (setq prdloc (list xprdloc spy3))
     (setq prd (rtos (* 12 prloc) 4 1))
     (command "layer" "s" "sooo" \r
              "dim" "vert" sp6 prpcl prdloc prd "exit"))
)
    ;FIND OUT IF THERE IS A TOP PIPE
     (setq ptop (getstring "\nIS THERE A PIPE ON THE TOP SIDE? (Y or N)"))
     (if (= ptop "Y") (progn
     ;GET INFO ON PIPE
     (setq ptdiam (getdist "\nWHAT IS THE DIAMETER OF THE TOP PIPE?"))
     (setq ptloc (getdist "\nDISTANCE FROM THE UPPER LEFT CORNER OF BOX TO THE CL OF PIPE?"))
     ;SET UP COORDINATES OF PIPE
     (setq xptpcl (+ ptloc spx2))
     (setq ptpcl (list xptpcl spy4))
     ;INSERT PIPES
     (command "layer" "s" "g3" \r
              "insert" "/acad/strblk/rcp" ptpcl 4 ptdiam 90)
     ;DRAW LOCATIONS OF PIPES
     (setq yptdloc (+ spy2 7))
     (setq ptdloc (list spx2 yptdloc))
     (setq ptd (rtos (* 12 ptloc) 4 1))
     (command "layer" "s" "sooo" \r
              "dim" "horiz" sp8 ptpcl ptdloc ptd "exit"))
)
    ;FIND OUT IF THERE IS A BOTTOM PIPE
     (setq pbot (getstring "\nIS THERE A PIPE ON THE BOTTOM SIDE? (Y or N)"))
     (if (= pbot "Y") (progn
     ;GET INFO ON PIPE
     (setq pbdiam (getdist "\nWHAT IS THE DIAMETER OF THE BOTTOM PIPE?"))
     (setq pbloc (getdist "\nDISTANCE FROM THE LOWER LEFT CORNER OF BOX TO THE CL OF PIPE?"))
     ;SET UP COORDINATES OF PIPE
     (setq xpbpcl (+ pbloc spx2))
     (setq pbpcl (list xpbpcl spy3))
     ;INSERT PIPES
     (command "layer" "s" "g3" \r
              "insert" "/acad/strblk/rcp" pbpcl 4 pbdiam 270)
     ;DRAW LOCATIONS OF PIPES
     (setq ypbdloc (- spy1 7))
     (setq pbdloc (list spx2 ypbdloc))
     (setq pbd (rtos (* 12 pbloc) 4 1))
     (command "layer" "s" "sooo" \r
              "dim" "horiz" sp5 pbpcl pbdloc pbd "exit"))
)
)


(defun C:BOXSPLAN ()
     (inbox)
     (bsp)
)
