(defun C:LISP()
	(load"\\acad\\acad")
)
(defun cmdon()
	(setvar"cmdecho"1)
)
(defun cmdoff()
	(setvar"cmdecho"0)
)
(defun C:TXTIN (/ va);V1.20

(defun *error* (st) (prompt (strcat "error: " st "\007\n")))

(defun FA (/ vb vc ve vf vg vh vi)
(setq vb (read-line va) vc (getstring "\nStyle name <STANDARD>: "))
(if (= vc "") (setq vc "STANDARD"))
(setq ve (getpoint "\nStarting point: "))
(setq vf (getdist ve
    (strcat "\nHeight <"
    (rtos (getvar "TEXTSIZE") (getvar "LUNITS") (getvar "LUPREC")) ">: ")))
(if (= vf nil) (setq vf (getvar "TEXTSIZE")))
(setq vg (getangle ve "\nRotation Angle <0>: "))
(if (= vg nil) (setq vg 0.0))
(setq vh (getvar "AUNITS"))
(setvar "AUNITS" 4)
(setq vi (getvar "BLIPMODE"))
(setvar "BLIPMODE" 0)
(setvar "CMDECHO" 0)
(command "TEXT" "S" vc ve vf vg vb)
(while (/= vb nil)
  (setq ve (polar ve (+ vg (* 1.5 pi)) (* (/ 5.0 3.0) vf )))
  (setq vb (read-line va))
  (command "TEXT" ve "" "" vb ))
(setvar "BLIPMODE" vi)
(setvar "AUNITS" vh)
(close va))

(setq va (open (getstring "\nName of ASCII file to insert: ") "r"))
(if (/= va nil) (FA) (prompt "File not found - try again\007\n"))
)
(defun BEEP()	
	(command "BEEP")
	(print)
)
(defun C:CST()
	(setvar"cmdecho"0)
	(command"CHANGE" "L" "" "P" "LA" "SO" "")
	(prin1)
)
(defun C:CGT()
	(setvar"cmdecho"0)
	(command"CHANGE" "L" "" "P" "LA" "GO" "")
	(prin1)
)
(defun C:CCA()
	(setvar"cmdecho"0)
	(command "CHANGE" ldr "" "P" "LA" "CO" "")
	(prin1)
)
(defun wblksave()
	(setvar "cmdecho" 0)
 	(setq savename (getstring "Save name: "))
	(command "SAVE" savename "Y" )(prin1)  
	(grtext -2 (strcat dw savename))(prin1)
)
(defun C:WSAVE()
	(setq dw "  DRAWING NAME  =  ")
	(wblksave)
)
        
(defun C:TIMER()
	(setvar "cmdecho" 0)
	(setq minutes (getint "How many minutes? "))
	(setq idelay (* 60 minutes))
	(repeat idelay
		(command "DELAY" "1000")
	)
	(command "BEEP")(PRINT)
)

;       Change substring in selected text entities

(defun c:EDTXT (/ p l n e os as ns st s nsl osl sl si chf chm)
        (setq p (ssget))
        (if p (progn
           (setq osl (strlen (setq os
                         (getstring "\nOld string: " t))))
           (setq nsl (strlen (setq ns
                         (getstring "\nNew string: " t))))
           (setq l 0)
           (setq chm 0)
           (setq n (sslength p))
           (while (< l n)
              (if (= "TEXT"
                     (cdr (assoc 0
                       (setq e (entget (ssname p l))))))
                 (progn
                    (setq chf nil)
                    (setq s (cdr (setq as (assoc 1 e))))
                    (setq si 1)
                    (while (= osl (setq sl (strlen
                                  (setq st (substr s si osl)))))
                       (if (= st os) (progn
                          (setq s (strcat (substr s 1 (1- si)) ns
                                          (substr s (+ si osl))))
                          (setq chf t)
                       ))
                       (setq si (1+ si))
                    )
                    (if chf (progn
                       (setq e (subst (cons 1 s) as e))
                       (entmod e)
                       (setq chm (1+ chm))
                    ))
                 )
              )
              (setq l (1+ l))
           )
        ))
        (terpri)(princ)
)

;       Delete all entities on specified layer

(defun c:DELLAYER ()
        (setq l (strcase (getstring "\nEnter layer to delete: ")))
        (setq e (entnext))
        (while e
           (if (= l (cdr (assoc 8 (entget e))))
              (entdel e)
           )
           (setq e (entnext e))(print)
        )
)

(defun c:ELL() ;ELLIPSE COMMAND
	(cmdoff)
	(command "ELLIPSE")(prin1)
)
(defun C:BOXNOTE()
	(cmdoff)(command "LAYER" "S" "CO" "")
	(command "STYLE" "STANDARD" "" "" "" "" "" "" "")
	(graphscr)
	(setq txtpt(getpoint "\nStart point:"))
	(prompt "\nText: ")(prin1)
	(command "DTEXT" txtpt)
	(command "")
	(command "LAYER" "S" "COO" "")
	(prompt "\nDraw box...")(prin1)
	(command "LINE")(prin1)
)
(defun C:NEWBASE()
	(cmdoff)
	(command "BASE" (setq nb(getvar"extmin")))
        (getvar"extmin")
)
(defun C:REF()
	(cmdoff)
	(command "VSLIDE" "REF")(prin1)
	(prompt "Viewing reference slide")(prin1)	
)
(defun C:AE()
	(cmdoff)
	(command"ATTEDIT" "" "" "" "")(prin1)
)
(defun C:VR()
	(cmdoff)
	(setq vn (getstring">"))
	(command "VIEW" "R" vn)(prin1)
)
(defun C:LEA()
	(cmdoff)
	(setq ldr(getpoint "Leader start: "))(prin1)
	(command "DIM1" "LEADER" ldr)
)
(defun C:STAR()
	(cmdoff)
	(setq repno (getint"\nNumber of points: "))
	(repeat repno
	(setq pt(getpoint"\nPoint: "))
	(command "TEXT" "M" "END" pt "0" "*" )(prin1))
)
(defun C:MINS()
	(cmdoff)
	(setq repno (getint"\nNumber of points/blocks: "))
	(setq blk(getstring"\nBlock name: "))
	(setq osv(getstring"Object snap value: "))
	(command"OSNAP" osv)
	(repeat repno
	(setq pt(getpoint"\nPoint: "))
	(command "INSERT" blk pt "1" "1" "0")(prin1))
	(command"OSNAP" "NONE")(prin1)
)
(defun C:P() ;piping layer command
	(cmdoff)
	(setq dl "p") ;set discipline prefix
	(setq lyr (getstring"Layer: "))
	(setq lyr (strcat dl lyr))
	(command "LAYER" "S" lyr "")(prin1)
)
(defun C:S() ;structural layer command
	(cmdoff)
	(setq dl "s") ;set discipline prefix
	(setq lyr (getstring"Layer: "))
	(setq lyr (strcat dl lyr))
	(command "LAYER" "S" lyr "")(prin1)
)(defun C:G() ;general layer command
	(cmdoff)
	(setq dl "g") ;set discipline prefix
	(setq lyr (getstring"Layer: "))
	(setq lyr (strcat dl lyr))
	(command "LAYER" "S" lyr "")(prin1)
)(defun C:C() ;civil layer command
	(cmdoff)
	(setq dl "c") ;set discipline prefix
	(setq lyr (getstring"Layer: "))
	(setq lyr (strcat dl lyr))
	(command "LAYER" "S" lyr "")(prin1)
)
