10 'PROGRAM NAME     <<<<GEAR>>>>  
20 KEY OFF:WIDTH 80:CLS
30 PRINT "BASIC PARAMETRIC GENERATED AUTOCAD (GEAR) DRAWING (ACAD VERSION 2.52)
40 PRINT "-------------------------------------------------"
50 INPUT "ENTER NUMBER OF TEETH       ",N
60 INPUT "ENTER PITCH DIAMETER        ",DP
70 INPUT "ENTER SHAFT DIAMETER        ",SD
80 INPUT "ENTER FACE DEPTH OF TEETH   ",F
90 INPUT "PRESS (P) FOR A PRINTOUT    ",P$
100  '================================================================
110 'INPUTED AND CALCULATED PARAMETERS"
120 PA=14.5              'PRESSURE ANGLE
130 RD=180/3.1416        'CONVERSION TO RADIANS
140 P=N/DP               'DIAMETRAL PITCH
150 A =1/P               'ADDENDUM
160 AC=1/P+DP            'ADDENDUM CIRCLE
170 B =1.157/P           'DEDENTUM
180 DC=(N+2)/P           'DEDENTUM CIRCLE
190 BC=DP*COS(PA/RD)     'BASE CIRCLE
200 AB=360/N             'ANGLE BETWEEN CENTER OF TEETH
210 TC=DP*SIN(90/RD/N)   'CHORDAL THICKNESS
220 DR=DP-2*B            'ROOT CIRCLE
230 WC=AC-2*A            'WORKING DEPTH CIRCLE
240 DO=DP+2*A            'OUTSIDE DIAMETER
250 FI=.157/DP           'TOOTH FILLET
260 PR=PC/2              'RADIUS OF PITCH DIAMETER
265 IF (DP/8) <= TC THEN BEEP: PRINT "MORE TEETH REQUIRED":GOTO 50
270  '================================================================
280 SAVE "GEAR.DWG":KILL"GEAR.DWG"
290 OPEN "GEAR.SCR" FOR OUTPUT AS #1
300 PRINT "WRITING TO SCRIPT FILE  (GEAR.SCR)"
310  '================================================================
320 S$="1"                                        :GOSUB 1240 'new drawing
330 S$=""                                         :GOSUB 1240
340 X=-DO/2:Y=-DO/2:XX=DO/2:YY=DO/2               :GOSUB 1240
350 S$="LIMITS "+X$+","+Y$+" "+XX$+","+YY$        :GOSUB 1240
360 S$="ZOOM ALL"                                 :GOSUB 1240
370 S$="APERTURE 40"                              :GOSUB 1240
380 S$="VIEWRES N 20000"                          :GOSUB 1240
390 S$="LAYER NEW RED,GREEN,BLUE "                :GOSUB 1240
400 S$="LAYER COLOR RED RED "                     :GOSUB 1240
410 S$="LAYER COLOR GREEN GREEN "                 :GOSUB 1240
420 S$="LAYER COLOR BLUE BLUE "                   :GOSUB 1240
430 S$="LAYER SET RED "                           :GOSUB 1240
440 X=F                                           :GOSUB 1240
450 S$="ELEV 0 "+X$                               :GOSUB 1240 'set elevation
460 DIA=DO                                        :GOSUB 1240
470 S$="CIRCLE 0,0 D "+DIA$                       :GOSUB 1240 'outside circle
480 DIA=BC                                        :GOSUB 1240
490 S$="CIRCLE 0,0 D "+DIA$                       :GOSUB 1240 'base circle
500 DIA=WC                                        :GOSUB 1240
510 S$="CIRCLE 0,0 D "+DIA$                       :GOSUB 1240 'working circle
520 Y=DR/2:YY=DO/2                                :GOSUB 1240
530 S$="LINE 0,"+Y$+" 0,"+YY$+" "                 :GOSUB 1240 'constr. line
540 X=-TC/2:Y=DP/2:XX=TC/2:YY=DP/2                :GOSUB 1240
550 S$="LINE "+X$+","+Y$+" "+XX$+","+YY$+" "      :GOSUB 1240 'constr. line
560 S$="LAYER SET GREEN "                         :GOSUB 1240
570 X=-SD/2:Y=0:XX=SD/2:YY=SD/2+SD/4              :GOSUB 1240
580 S$="ZOOM W "+X$+","+Y$+" "+XX$+","+YY$        :GOSUB 1240
590 X=-SD/4:XX=SD/4                               :GOSUB 1240
600 S$="ELEV "+X$+" "+XX$                         :GOSUB 1240 'set elevation
610 X=SD+SD/2                                     :GOSUB 1240
620 S$="CIRCLE 0,0 D "+X$                         :GOSUB 1240 'uppr shaft shldr
630 X=F:XX=SD/4                                   :GOSUB 1240
640 S$="ELEV "+X$+" "+XX$                         :GOSUB 1240 'set elevation
650 X=SD+SD/2                                     :GOSUB 1240
660 S$="CIRCLE 0,0 D "+X$                         :GOSUB 1240 'lowr shaft shldr
670 X=F                                           :GOSUB 1240
680 S$="ELEV 0 "+X$                               :GOSUB 1240 'set elevation
690 X=0:Y=SD/2:XX=SD/4                            :GOSUB 1240
700 S$="CIRCLE "+X$+","+Y$+" D "+XX$              :GOSUB 1240 'constr. circle
710 X=-SD/4:XX=F+2*SD/4                           :GOSUB 1240
720 S$="ELEV "+X$+" "+XX$                         :GOSUB 1240 'set elevation
730 DIA=SD                                        :GOSUB 1240
740 S$="CIRCLE 0,0 D "+DIA$                       :GOSUB 1240 'shaft diameter
750 X=-SD/8:Y=SD/2:XX=SD/8:YY=SD/2+SD/8           :GOSUB 1240 'keyway line
76 S$="LIN IN "+X$+","+Y$+ "+X$+","+YY$+ 
         "+XX$+","+YY$+ IN "+XX$+","+Y$+      :GOSU 1240
770 Y=SD/2-(SD/4)/2                               :GOSUB 1240 'erase const. cir
780 S$="ERASE NEAR 0,"+Y$+" "                     :GOSUB 1240
790 X=SD/8:XX=-SD/8:Y=SD/2                        :GOSUB 1240
800 S$="BREAK NEAR 0,"+Y$+" F INT "+
      X$+","+Y$+" INT "+XX$+","+Y$                :GOSUB 1240
810 X=F                                           :GOSUB 1240
820 S$="ELEV 0 "+X$                               :GOSUB 1240 'set elevation
830 DIA=DR                                        :GOSUB 1240
840 S$="CIRCLE 0,0 D "+DIA$                       :GOSUB 1240 'root diameter
850 X=-DP/8:Y=DP/2-DP/8:XX=DP/8:YY=DP/2+DP/8      :GOSUB 1240
851 S$="ZOOM e"                                   :GOSUB 1240
860 S$="ZOOM W "+X$+","+Y$+" "+XX$+","+YY$        :GOSUB 1240
870 X=-TC/2:Y=DP/2:XX=DP/8                        :GOSUB 1240
880 S$="CIRCLE END "+X$+","+Y$+" "+XX$            :GOSUB 1240 'constr. circle
890 DIA=DP                                        :GOSUB 1240
900 S$="CIRCLE 0,0 D "+DIA$                       :GOSUB 1240 'pitch circle
910 S$="ERASE L "                                 :GOSUB 1240 'erase circle
920 X=DP/8-TC/2:Y=BC/2:XX=DP/8                    :GOSUB 1240
930 S$="CIRCLE int "+X$+","+Y$+" "+XX$            :GOSUB 1240 'constr. circle
940 X=-TC/2:Y=DP/2+DP/8                           :GOSUB 1240
950 S$="ERASE NEAR "+X$+","+Y$+" "                :GOSUB 1240 'erase circle
960 X=DP/8-TC/2:Y=BC/2+DP/8                       :GOSUB 1240
970 XX=-TC/2:YY=DR/2:XXX=-TC/4:YYY=DO/2           :GOSUB 1240
980 S$="BREAK NEAR "+X$+","+Y$+" F "+"
       INT "+XX$+","+YY$+" INT "+XXX$+","+YYY$    :GOSUB 1240 'break circle
990 X=-TC:Y=DR/2-1:YY=DO/2+1:DIA=DO               :GOSUB 1240
1000 S$="MIRROR W "+X$+","+Y$+" "+"0,"+YY$+
           "  0,0 0,"+DIA$+" N"                    :GOSUB 1240 'mirror tooth arc
1010 X=-TC/4:Y=DO/2:XX=TC/4:YY=DO/2                :GOSUB 1240
1020 S$="LINE INT "+X$+","+Y$+" INT "+XX$+
        ","+YY$+" "                                :GOSUB 1240 'connect arcs
1030 S$="LAYER OFF * Y "                           :GOSUB 1240 'all layers off
1040 S$="LAYER ON RED "                            :GOSUB 1240
1050 S$="ZOOM E"                                   :GOSUB 1240
1060 X=-DO/2:Y=-DO/2:XX=DO/2:YY=DO/2               :GOSUB 1240
1070 S$="ERASE W "+X$+","+Y$+" "+XX$+","+YY$+" "   :GOSUB 1240 'erase const.
1080 S$="LAYER ON GREEN "                          :GOSUB 1240
1090 X=-TC:Y=DR/2-.2:XX=TC:YY=DO/2+.2:XXX=DR/2     :GOSUB 1240
1130 S$="ARRAY W "+X$+","+Y$+" "+XX$+","+YY$+
        "  C CENTER "+XXX$+",0 "+AB$+" "+N$+" Y"   :GOSUB 1240 'array tooth
1140 S$="VPOINT -1,2,3"                            :GOSUB 1240
1150 S$="HIDE"                                     :GOSUB 1240
1160 CLOSE #1
1170 '================================================================
1180 IF P$ ="P" OR P$ = "p" THEN GOSUB 1390  'PRINTOUTS
1190 PRINT "CONVERT SCRIPT FILE TO AUTOCAD DRAWING FILE"
1200 SHELL "ACAD GEAR GEAR"  'CONVERT SCRIPT TO DRAWING FILE
1210 CLS:PRINT "BACK IN BASIC"
1220 END
1230 '================================================================
1240 'ROUTINE TO CONVERT TO STRINGS AND REMOVE LEADING BLANKS
1250 X$  =STR$(X)  :IF LEFT$(X$,1)   = " " THEN X$   =MID$(X$,2)
1260 XX$ =STR$(XX) :IF LEFT$(XX$,1)  = " " THEN XX$  =MID$(XX$,2)
1270 XXX$=STR$(XXX):IF LEFT$(XXX$,1) = " " THEN XXX$ =MID$(XXX$,2)
1280 Y$  =STR$(Y)  :IF LEFT$(Y$,1)   = " " THEN Y$   =MID$(Y$,2)
1290 YY$ =STR$(YY) :IF LEFT$(YY$,1)  = " " THEN YY$  =MID$(YY$,2)
1300 YYY$=STR$(YYY):IF LEFT$(YYY$,1) = " " THEN YYY$ =MID$(YYY$,2)
1310 AB$ =STR$(AB) :IF LEFT$(AB$,1)  = " " THEN AB$  =MID$(AB$,2)
1320 N$  =STR$(N)  :IF LEFT$(N$,1)   = " " THEN N$   =MID$(N$,2)
1330 DIA$=STR$(DIA):IF LEFT$(DIA$,1) = " " THEN DIA$ =MID$(DIA$,2)
1340 '
1350 IF S$ <> "    "  THEN PRINT #1,S$  'write to script file (GEAR.SCR)
1360 S$="    "                          'BLANK OUT STRING
1370 RETURN
1380 '================================================================
1390 LPRINT "LIST OF INPUTED AND CALCULATED PARAMETERS"
1400 LPRINT "-------------------------------------------"
1410 LPRINT "NUMBER OF TEETH -----------  N = ",N
1420 LPRINT "TOOTH FACE DEPTH ----------  F = ",F
1430 LPRINT "TOOTH FILLET --------------  FI= ",FI
1440 LPRINT "PITCH CIRCLE DIAMETER -----  DP= ",DP
1450 LPRINT "PRESSURE ANGLE ------------  PA= ",PA
1460 LPRINT "DIAMETRAL PITCH -----------  P = ",P
1470 LPRINT "ADDENDUM-------------------  A = ",A
1480 LPRINT "ADDENDUM CIRCLE -----------  AC= ",AC
1490 LPRINT "DEDENTUM ------------------  B = ",B
1500 LPRINT "DEDENTUM CIRCLE -----------  DC= ",DC
1510 LPRINT "BASE CIRCLE ---------------  BC= ",BC
1520 LPRINT "ANGLE BETWEEN TEETH -------  AB= ",AB
1530 LPRINT "TOOTH CHORDAL THICKNESS ---  TC= ",TC
1540 LPRINT "ROOT CIRCLE ---------------  DR= ",DR
1550 LPRINT "WORKING DEPTH CIRCLE ------  WC= ",WC
1560 LPRINT "OUTSIDE DIAMETER ----------  DO= ",DO
1570 LPRINT:LPRINT:LPRINT
1580 LPRINT "PRINT OF SCRIPT FILE (GEAR.SCR)"
1590 SHELL "TYPE GEAR.SCR >PRN"
1600 RETURN
1610 '================================================================
