; GTEXTCHG allows the user to GLOBALLY change text parameters.
;          All or selected text can be changed.
;          The ANGLE, HEIGHT, LAYER, WIDTH, or STYLE may be modified.
;
; Original: Harry Geiger, CADalyst, Jan 1988 (V4 #7) p.93
; Improved: Howard M. Fulmer/HMF CONSULTING, Apr 1989 (215) 275-9866
;
(defun C:GTEXTCHG ()
   (prompt "*** GLOBAL TEXT CHANGER ***")
   (setvar "CMDECHO" 0)
   (setq COUNT -1)
   (setq FLAG "T")
   (initget 1 "A S")
   (setq SCOPE (getkword "\nChange All/Selected text: "))
   (prompt "Gathering data...")
   (if (= SCOPE "A")
       (setq OLD (ssget "X" (list (cons 0 "TEXT"))))
       (setq OLD (ssget))
   )
   (prompt (strcat "\n" (itoa (sslength OLD)) " object(s) gathered."))
   (initget 1 "A H L W S")
   (setq TYP (getkword "\nChange Angle/Height/Layer/Width/Style: "))
   (cond
     ((= "A" TYP)
       (setq
          ITEM 51
          VAL (* PI (/ (getreal "New angle: ") 180.0))
       )
     )
     ((= "H" TYP)
       (setq
          ITEM 40
          VAL (getreal "New height: ")
       )
     )
     ((= "L" TYP)
       (setq
          ITEM 8
          VAL (getstring "New layer: ")
       )
     )
     ((= "W" TYP)
       (setq
          ITEM 41
          VAL (getreal "New width: ")
       )
     )
     ((= "S" TYP)
       (setq
          ITEM 7
          VAL (getstring "New style: ")
       )
     )
   )
   (prompt "Working... ")
   (terpri)
   (while FLAG
      (progn
         (setq
            COUNT (1+ COUNT)
            TEMP (entget (ssname OLD COUNT))
            OLDVAL (assoc ITEM TEMP)
            NEWVAL (cons ITEM VAL)
            NEWTEXT (subst NEWVAL OLDVAL TEMP)
            FLAG (ssname OLD (1+ COUNT))
         )
         (entmod NEWTEXT)
         (prompt (strcat "\r" (itoa COUNT)))
         )
   )
   (prompt (strcat "\r" (itoa (1+ COUNT)) " object(s) changed."))
   (prin1)
)
(defun *error* (msg)
   (princ "error: ")
   (princ msg)
   (terpri)
)
(prompt "GTEXTCHG loaded.")
(prin1)
