

(defun getgeometry()
; Initialize variables  
 (setq namelist nil 
       TMx 0.0    TMy 0.0    TArea 0.0    TIx 0.0    TIy 0.0    
       TIxy 0.0   i 0        Xbar 0.0     Ybar 0.0   Ixbar 0.0 
       Iybar 0.0  Ixybar 0.0 Ix 0.0       Iy 0.0     Ixy 0.0      
       Areaf 0.0  Icx 0.0    Icy 0.0      Icxy 0.0   Ic 0.0  
       My 0.0     Mx 0.0     Areac 0.0    Mcx 0.0    Mcy 0.0 )
 (terpri)
 (prompt "\nSelect cross section including holes")
 (setq namelist (ssget))                             
 (prompt "\nPlease select an entity on the cross section edge")
 (prompt "\nEntity must be a CIRCLE, ARC or a LINE  !!!")
 (setq entity (entsel "\nSelect entity "))   
 (repeat 5 (princ "\n "))
 (prompt "\nPlease wait ...")
 (setq ename (car entity)
       en (entget ename)
       TypeOfentety (cdr (assoc 0 en)))    
 (if (= typeofentety "CIRCLE")           
  (progn
    (ssdel ename namelist)                        
    (entdel ename)             
    (setq Center_pt (cdr (assoc 10 en))    Cptx (car center_pt) 
          Cpty (cadr center_pt)            Rad  (cdr (assoc 40 en))
          Tarea (* pi rad rad )            Ic (* pi(expt rad 4.0)0.25)
          TIxy  (* Tarea cptx cpty)        TIx (+ Ic(* Tarea cpty cpty))
          TIy  (+ Ic (* Tarea cptx cptx )) TMx  (* Tarea cptx)
          TMy  (* Tarea Cpty))                    
     (entdel ename))
    (progn                                            
     (ssdel ename namelist)                       
     (ssadd ename namelist)
     (procLINE_ARC_CIRCLE)
     (setq areaf (- areaf)    MX (- MX)    Iy (- Iy))
     (if (minusp areaf)
      (progn
       (setq areaf (- areaf)    MX (- MX)    MY (- MY)    Iy (- Iy)
             Ix (- Ix)          Ixy (- Ixy))))
  (setq Tarea areaf    TMx Mx     TMy My    TIx Ix 
        TIy Iy         TIxy Ixy))))

; ProcLINE_ARC_CIRCLE  process each line a arc in NAMELIST until 
; a close loop is performed

(defun ProcLINE_ARC_CIRCLE ()       
 (setq  Ix 0.0    Iy 0.0    Ixy 0.0    Areaf 0.0

        My 0.0    Mx 0.0    num (1-(sslength namelist))
        ename (ssname namelist num)
        en ( entget ename ) lastname  ename
        Firstname ename)
 (entdel lastname)                               
 (setq TypeOfentety (cdr (assoc 0 en)))          
 (if (= typeOfentety "LINE")          
  (progn
   (setq origin_pt (cdr (assoc 10 en))
         exit nil))    
  (progn
   (if (= typeOfentety "ARC")          
    (progn
     (setq Center_pt (cdr (assoc 10 en))
           Rad (cdr (assoc 40 en))
           sang (cdr (assoc 50 en) )
           origin_pt (polar Center_pt sang Rad)
           exit nil))
    (progn
     (if (= typeofentety  "CIRCLE")
      (procCircle)
      (*error* "Unknown entity. Unable to continue ...."))))))
 (setq new_pt origin_pt )      
 (while (not exit)                                 
  (setq uplf (polar new_pt 2.3562  0.005)
        lwrt (polar new_pt 5.4978  0.005)
        onenamelist (ssget "C"  uplf  lwrt)
        ename (ssname onenamelist 0)
        en ( entget ename ))            
  (ssdel ename namelist)
  (entdel ename)
  (entdel lastname)
  (setq lastname ename
        TypeOfentety (cdr (assoc 0 en))) 
  (if (= typeOfentety "LINE")
   (ProcLine)
    (if (= typeOfentety "ARC")
     (ProcArc))))
 (entdel lastname))

(defun ProcLine()
 (setq start_pt (cdr (assoc 10 en))
       end_pt (cdr (assoc 11 en))
       nx (car new_pt)     ny (cadr new_pt) 
       sx (car start_pt)   sy (cadr start_pt) 
       DX (abs(- sx nx))   Dy (abs(- sy ny)))
 (if ( and (< dx 0.000001) (< dy 0.000001)) 
  (progn 
   (prop start_pt end_pt)
   (setq new_pt end_pt)       
   (if (eq firstname  ename) (setq exit t)))
  (progn 
   (prop end_pt start_pt) 
   (setq new_pt start_pt)
   (if (eq firstname ename) (setq exit t)))))

(defun Procarc ()
 (setq Center_pt (cdr (assoc 10 en))    Rad (cdr (assoc 40 en))
       sang  (cdr (assoc 50 en) )       eang (cdr(assoc 51 en))
       nx  (car new_pt)                 ny (cadr new_pt) 
       sp (polar Center_pt sang Rad)    ep (polar Center_pt eang rad) 
       gsx (car sp)                     sy (cadr sp) 
       Dx (abs (- sx nx))               Dy (abs (- sy ny)))              
 (if (> sang eang)
  (setq angdis (- (* 2.0 PI) (- sang eang)))   
  (setq angdis (- eang sang)))
 (if ( and (< DX 0.00001) (< DY 0.00001)) 
  (progn 
   (setq new_pt ep)
   (ProcA)
   (if (eq firstname ename ) (setq exit t)))
  (progn 
   (setq new_pt sp)        
   (ProcB)
   (if (eq firstname ename ) (setq exit t)))))
 
( defun ProcA (/ delta newang  j)

; note that delta is set to five (5) degrees. If you need more precision in

; your results you may want to decrease this number, but you will pay a 
; penalty for it - TIME.

 (setq delta (* 5.0 pi (/ 1.0 180.0))
       newang (+ sang delta)
       j (/ angdis delta)
       j (abs (fix j))  )
 (repeat j
  (setq ep (polar center_pt newang  Rad))
  (Prop sp ep)           
  (setq sp ep
        newang (+ newang delta))) 
 (Prop sp new_pt))

( defun ProcB (/ delta newang  j)
 (setq delta (* -5.0 pi (/ 1.0 180.0))
       newang (+ eang delta)
       j (/ angdis delta)
       j (abs (fix j)) )
 (repeat j
  (setq sp (polar center_pt newang  Rad))
  (Prop ep sp)
  (setq ep sp 
        newang (+ newang delta))) 
 (Prop ep new_pt))

(defun ProcCIRCLE ()
 (setq exit t)
 (ssdel ename namelist)
 (setq Center_pt (cdr (assoc 10 en))     Cptx (car center_pt) 
       Cpty (cadr center_pt)             Rad  (cdr (assoc 40 en))
       area1 (* pi rad rad -1.0 )        Ic (* pi (expt rad 4.0) -0.25)
       Icxy (* area1 cptx cpty)          Icx (+ Ic(* area1 cpty cpty))
       Icy  (+ Ic (* area1 cptx cptx ))  MCx (* area1 cptx)
       MCy (* area1 Cpty)                Tarea (+ Tarea area1)
       TMx   (+ TMx MCx)                 TMy   (+ TMy MCy)
       TIx   (+ TIx Icx)                 TIy   (+ TIy Icy)
       TIxy  (+ TIxy Icxy)))

; this part of the program computes the properties
; Area, Ix,Iy, Xbar, Ybar, Ixy about the origin (0,0)

( defun prop (pti ptj / Yj Yi Xj Xi K1 K2 K3 K4
                         K11 K22 K33 K44 C1 C2 C3)
 (setq Yj (cadr ptj)   Xj (car  Ptj)    Yi (cadr Pti)
       Xi (car  Pti)   k1 (- Yj Yi)     k11 (* k1 k1)
       k2 (+ Xj Xi)    k22 (* k2 k2)    k3 (- Xj Xi)
       k33 (* k3 k3)   k4 (+ Yj Yi)     K44 (* k4 k4)
       Areaf (+ Areaf (* 0.5 k1 k2))
       MX  (+ MX (* (/ k1 8.0) (+ k22 (/ k33 3.0))))
       MY  (+ MY (* (/ k3 8.0) (+ k44 (/ k11 3.0))))
       Ix (+ Ix (* (* k3 k4 (/ 1.0 24.0)) (+ k44 k11)))
       Iy (+ Iy (* (* k1 k2 (/ 1.0 24.0)) (+ k22 k33)))
       strzero (rtos  (abs k3)  2 4))
 (if (not (= strzero 0.0000))
  (progn 
   (setq c1  (*  0.125 k11 k2 (+ (* Xj Xj) (* Xi Xi)))
         c2  (*  (/ 1.0 3.0)  k1  (-  (*  Xj Yi) (*  Xi Yj) )
             (+  (* Xj Xj) (* Xj Xi) (* Xi Xi)))
         c3  (*  0.25  (- (* Xj Yi) (* Xi Yj))
             (- (* Xj Yi) (* Xi Yj))(+ Xj  Xi))
         Ixy (+ Ixy  (*  (/ 1.0 k3) (+ c1 c2 c3)))))))

(defun Output ()
 (setq Xbar (/  TMX TArea)  Ybar (/  TMY TArea)
       Ix TIx     Iy TIy    Ixy TIxy     areaf Tarea
       IXbar (- Ix (* Areaf Ybar Ybar))
       Iybar (- Iy (* Areaf Xbar Xbar))
       Ixybar (-  Ixy  (*  Areaf  Xbar Ybar))
       c1 (ATOF (RTOS (- (* 2  Ixybar))   2 4))
       c2 (ATOF (RTOS (- Ixbar  Iybar )  2 4)))
 (IF (NOT ( ZEROP C2))
  (setq Alpha (* 0.5 (atan (/ c1 c2))))
  (SETQ ALPHA 0.0))
 (setq Cx2 (* (cos alpha) (cos alpha))    Cy2 (* (sin alpha) (sin alpha))
       Cy  (sin (* 2 alpha))              Cx  (cos (* 2 alpha))
       Ixp(+(* Ixbar Cx2)(* Iybar Cy2))   Ixp (- Ixp (* Ixybar cy))
       Iyp (+(* Iybar Cx2)(* Ixbar Cy2))  Iyp (+ Iyp (* Ixybar cy ))
       Ixyp (+ (* (/ c2 2.0 ) cy ) (* Ixybar cx))

       Alpha (* alpha 180.0 (/ 1.0 pi)))
 (command "SHELL"  "CLS")
 (textscr)
 (prin1)
 (princ "\nSECTION PROPERTIES")
 (princ "\nArea =  ") (princ (rtos areaf 2 4))
 (princ "\nXbar =  ") (princ (rtos Xbar        2 4))
 (princ "\nYbar =  ") (princ (rtos Ybar        2 4))
(prinC "\n")(princ "\nProperties about ORIGIN point  ")
 (setq ny " Y = 0.0000 )" 
       nx "( X = 0.0000 " )
 (princ nx)(princ ny)
 (princ "\nIx   =  ") (princ (rtos Ix  2 4))
 (princ "\nIy   =  ") (princ (rtos Iy  2 4))
 (princ "\nIxy  =  ") (princ (rtos Ixy 2 4))
 (princ "\n")
 (princ "\nProperties about Centroid  ")
 (setq nx (strcat "( X = " (rtos Xbar 2 2))
       ny (strcat " Y = " (rtos  Ybar 2 2)))
 (princ nx)(princ ny)(princ ")")
 (princ "\nIx   =  ") (princ (rtos  Ixbar 2 4))
 (princ "\nIy   =  ") (princ (rtos  Iybar 2 4))
 (princ "\nIxy  =  ") (princ (rtos  Ixybar      2 4))
 (princ "\n")
 (princ "\nPrincipal Properties about Centroid  ")
 (setq nx (strcat "( X = " (rtos Xbar 2 2))
       ny (strcat " Y = " (rtos  Ybar 2 2)))
 (princ nx)(princ ny)(princ ")")
 (princ "\nIx'   =  ") (princ (rtos Ixp 2  4))
 (princ "\nIy'   =  ") (princ ( rtos Iyp 2 4 ))
 (princ "\nIxy'  =  ") (princ ( rtos Ixyp 2 4 ))
 (princ "\nAlpha =  ") (princ ( rtos  alpha  2  4))
 (princ "\n"))

(defun testout ()
 (princ "\nCIRCLE TEST  ")
 (princ "\n AREA =  ") (princ (rtos AREAC 2 4))
 (princ "\nIcx   =  ") (princ (rtos Icx 2  4))
 (princ "\nIcy   =  ") (princ ( rtos Icy 2 4 ))
 (princ "\nIcxy  =  ") (princ ( rtos Icxy 2 4 ))
 (princ "\nMX     =  ") (princ ( rtos MX 2 4))
 (princ "\nMy     =  ") (princ ( rtos My 2 4))
 (prin1))

(defun *error* (st)
 (entdel ename)
 (repeat 5 (princ "\n "))
 (princ "\nerror : ")
 (princ st)
 (redraw ename 3)
 (getstring "\ntype CTRL C to end program ...  "))

;This is the main program

(defun c:Inertia()
 (getgeometry)
 (while (> (sslength namelist) 0)      
  (procLINE_ARC_CIRCLE)                  
  (setq areaf (- areaf)    MX (- MX)    Iy (- Iy))
  (if (minusp areaf)
   (progn            
    (setq Tarea (+ Tarea areaf)    TMx   (+ TMx Mx)
          TMy   (+ TMy My)         TIx   (+ TIx Ix)
          TIy   (+ TIy Iy))        TIxy  (+ TIxy Ixy)))
   (progn
    (setq areaf (- areaf)          MX (- MX)
          MY (- MY)                Iy (- Iy)
          Ix (- Ix)                Ixy (- Ixy)
          Tarea (+ Tarea areaf)    TMx   (+ TMx Mx)
          TMy   (+ TMy My)         TIx   (+ TIx Ix)
          TIy   (+ TIy Iy)         TIxy  (+ TIxy Ixy))))
 (Output)
 (PRIN1))    ;end of inertia.lsp
