(defun C:MORF (/ LAY1 LAY2 FRAMENUM PREF SCRNAM SSET1 
SSET2
THISLINE COUNT LINENUM DELTFILE DX1 DY1 DX2 DY2 SCRPT 
FRAME FRAMENAM)
;
;.................................................................
;
;MORF.LSP
;Program for Metamorphosis or "Tweening" animation frames
;
;October, 1987 by Ken Segal
;c/o Space Design Incorporated
;One Penn Square West, Suite #600
;30 South 15th Street,
;Philadelphia, PA 19102
;(215) 981-1492
;
;......................................................
...........
;
(setq *ERROR* (s)
(close DELTFILE)
(close SCRPT)
(redraw)
(print s)
(setq *ERROR* nil)
)
;
;
(setq LAY1 (getstring "\nWhat is name of startframe layer? ")
      LAY2 (getstring "\nWhat is name of endframe layer? ")
)
(while (< FRAMENUM 2)
(setq FRAMENUM (getint "\nHow many total frames in animation? "))
(if (< FRAMENUM 2) (prompt "\nMUST BE 2 OR MORE FRAMES!..."))
)
(while (null PREF)
(setq PREF(getstring"\nWhat is the prefix name for your slides? "))
(if(>(strlen PREF)(- 8 (strlen(itoa FRAMENUM))))
   (progn
      (setq PREF nil)
      (prompt (strcat "\nMUST BE " (itoa(- 8(strlen(itoa FRAMENUM))))
                    " OR LESS CHARACTERS!..."))
   )
)
)
(while (null SCRNAM)
(setq SCRNAM(getstring "\nWhat is the name for the script-file? "))
(if (> (strlen SCRNAM) 8) (progn
                          (setq SCRNAM nil)
                   (prompt "\nMUST BE 8 OR LESS CHARACTERS!...")
                          )
)
)
;
;SORT LINES BY LAYER
;INTO STARTFRAME AND ENDFRAME
;
(prompt "\nSORTING LINES...PLEASE WAIT!...")
   (setq SSET1 (ssadd) SSET2 (ssadd) THISLINE (entnext))
   (while (not(null THISLINE))
      (if(equal(cdr(assoc 8(entget THISLINE))) LAY1)
         (ssadd(cdr(assoc -1(entget THISLINE))) SSET1)
      (if(equal(cdr(assoc 8(entget THISLINE))) LAY2)
        (ssadd (cdr(assoc -1(entget THISLINE))) SSET2)
      )
      )
         (setq THISLINE(entnext THISLINE))
   )
   (setq COUNT (min (sslength SSET1) (sslength SSET2)))
;
;CALCULATE DELTAS, OR VECTORS FOR EACH
; LINE ENDPOINT
;
(command "LAYER" "T" "*" "S" LAY1 "F" "*" "")
(prompt "\nCALCULATING MOTION VECTORS...PLEASE WAIT!...")
(setq LINENUM 0)
(setq DELTFILE (open "DELTAXXX.XXX" "w"))
(while (< LINENUM COUNT)
   (setq
DX1(/ (- (cadr(assoc 10(entget(ssname SSET2 LINENUM))))
            (cadr(assoc 10(entget(ssname SSET1 LINENUM)))))
                (1- FRAMENUM))
DY1(/ (- (caddr(assoc 10(entget(ssname SSET2 LINENUM))))
            (caddr(assoc 10(entget(ssname SSET1 LINENUM)))))
                (1- FRAMENUM))
DX2(/ (- (cadr(assoc 11(entget(ssname SSET2 LINENUM))))
            (cadr(assoc 11(entget(ssname SSET1 LINENUM)))))
                (1- FRAMENUM))
DY2(/ (- (caddr(assoc 11(entget(ssname SSET2 LINENUM))))
            (caddr(assoc 11(entget(ssname SSET1 LINENUM)))))
                (1- FRAMENUM))
DX1 (rtos DX1 2 8) DY1 (rtos DY1 2 8) DX2 (rtos DX2 2 8)
DY2 (rtos DY2 2 8)
   )
(write-line DX1 DELTFILE)
(write-line DY1 DELTFILE)
(write-line DX2 DELTFILE)
(write-line DY2 DELTFILE)
   (setq LINENUM(1+ LINENUM))
)
(close DELTFILE)
;
;LOOP THROUGH ANIMATION FRAMES, 
;CREATING, "MSLIDING" EACH AND WRITING .SCR FILE
;
(setq SCRPT (open (strcat SCRNAM ".SCR") "w"))
(setq FRAME 1)
(while (<= FRAME FRAMENUM)
   (setq FRAMENAM (strcat PREF (ITOA FRAME)))
   (command "MSLIDE" FRAMENAM)
   (command "SAVE" FRAMENAM)
   (write-line (strcat "VSLIDE " FRAMENAM) SCRPT)
   (if (< FRAME FRAMENUM)
      (progn
;
;CALCULATE AND REDRAW EACH FRAME
;OF ANIMATION
;
(setq DELTFILE(open "DELTAXXX.XXX" "r"))
(SETQ LINENUM 0)
(while (< LINENUM COUNT)
(setq DX1 (read-line DELTFILE)
      DY1 (read-line DELTFILE)
      DX2 (read-line DELTFILE)
      DY2 (read-line DELTFILE)
      DX1 (atof DX1) DY1 (atof DY1) DX2 (atof DX2)
      DY2 (atof DY2)
)
(entmod(subst(list 10
            (+ DX1
            (cadr(assoc 10(entget(ssname SSET1 LINENUM)))))
            (+ DY1
            (caddr(assoc 10(entget(ssname SSET1 LINENUM)))))
            )
            (assoc 10(entget(ssname SSET1 LINENUM)))
            (entget(ssname SSET1 LINENUM))
       )
)
(entmod(subst(list 11
            (+ DX2
            (cadr(assoc 11(entget(ssname SSET1 LINENUM)))))
            (+ DY2
            (caddr(assoc 11(entget(ssname SSET1 LINENUM)))))
            )
            (assoc 11(entget(ssname SSET1 LINENUM)))
            (entget(ssname SSET1 LINENUM))
       )
)
(setq LINENUM (1+ LINENUM))
   ); LINENUM=COUNT...LAST LINE
(close DELTFILE)
)
)
   (setq FRAME (1+ FRAME))
)
   (close SCRPT)
(command "del" "DELTAXXX.XXX")
)
