;;;===========================================================================
;;;  Title: PLOT-DEF.LSP        Author: Christopher C. Bachman
;;;
;;;  Description: Used to process the attribute values contained in
;;;               PLOT-DEF blocks to provide automated plotting.
;;;===========================================================================
(setq cnt -1 block-tst nil)
; Get layer name of PLOT-DEF block.
(setq layer-name (getstring "\nEnter layer name of plot definition. "))
; Find all block references named PLOT-DEF.
(setq s1 (ssget "X" '((0 . "INSERT") (2 . "PLOT-DEF"))))
(if (null s1)                                     ; Test if blocks were found.
 (prompt "\nBlock PLOT-DEF not found.")
 (setq e (ssname s1 (setq cnt (1+ cnt)))))
(while e                                          ; Process PLOT-DEF blocks.
 (setq block-def (entget e))
 (if (= (cdr (assoc 8 block-def)) layer-name)     ; Test layer name of block.
  (progn
   ; Access and process attributes from block PLOT-DEF.
   ; The attributes must exist in the order that they are processed.
   (setq e (entnext e)) (setq d (entget e)) (setq corner#1 (cdr (assoc 1 d)))
   (setq e (entnext e)) (setq d (entget e)) (setq corner#2 (cdr (assoc 1 d)))
   (setq e (entnext e)) (setq d (entget e)) (setq paper-size (cdr (assoc 1 d)))
   (setq e (entnext e)) (setq d (entget e)) (setq plot-scale (cdr (assoc 1 d)))
   (setq e (entnext e)) (setq d (entget e)) (setq pen#1 (cdr (assoc 1 d)))
   (setq e (entnext e)) (setq d (entget e)) (setq pen#2 (cdr (assoc 1 d)))
   (setq e (entnext e)) (setq d (entget e)) (setq pen#3 (cdr (assoc 1 d)))
   (setq e (entnext e)) (setq d (entget e)) (setq pen#4 (cdr (assoc 1 d)))
   (setq e (entnext e)) (setq d (entget e)) (setq pen#5 (cdr (assoc 1 d)))
   (setq e (entnext e)) (setq d (entget e)) (setq pen#6 (cdr (assoc 1 d)))
   (setq e (entnext e)) (setq d (entget e)) (setq pen#7 (cdr (assoc 1 d)))
   (setq pen-l (list 'pen#1 'pen#2 'pen#3 'pen#4 'pen#5 'pen#6 'pen#7))
   (setq block-tst "Done")))
 (if (= block-tst "Done")                         ; Next block if not "Done".
  (setq e nil) (setq e (ssname s1 (setq cnt (1+ cnt)))))
)
(if (and (not (null s1)) (not (= block-tst "Done")))
 (prompt (strcat "\nLayer " layer-name " contains no definition.")))
(if (= block-tst "Done")                          ; Create script if "Done".
 (progn
  (setq plotfile (open "plot-def.scr" "w"))
  (write-line "PLOT" plotfile) (write-line "W" plotfile)
  (write-line corner#1 plotfile) (write-line corner#2 plotfile)
  (write-line "Y" plotfile) (write-line "Y" plotfile)
  (setq cnt -1)
  (repeat 7
   (write-line (eval (nth (setq cnt (1+ cnt)) pen-l)) plotfile)
   (write-line "0" plotfile) (write-line "36" plotfile)
  )
  (write-line "X" plotfile) (write-line "N" plotfile)
  (write-line "I" plotfile) (write-line "0.00,0.00" plotfile)
  (write-line paper-size plotfile)
  (write-line "N" plotfile) (write-line "0.010" plotfile)
  (write-line "N" plotfile) (write-line "N" plotfile)
  (write-line plot-scale plotfile)
  (close plotfile)
  (command "script" "plot-def")))                 ; Run PLOT-DEF script.
(prin1)
